// ICsParserInterface.h

#pragma once

//--------------------------------------------------------------
// ICsParserInterface
//--------------------------------------------------------------

namespace ICsParserInterface
{
	// alloc/free memory
	void * alloc ( size_t size );
	void free ( void * address );

	enum license_error
	{
		license_error_ok, // license ok
		license_error_bad, // incorrect license
		license_error_trial_ok, // trial period not expired
		license_error_trial_expired, // trial period expired
	};

	// license
	license_error setLicense ( const char * license );
	license_error checkLicense();

	struct VersionInfo
	{
		unsigned __int16 MajorVersion;
		unsigned __int16 MinorVersion;
		unsigned __int16 BuildNumber;
		unsigned __int16 RevisionNumber;
	};

	void getVersionInfo ( VersionInfo & info );
	const char * getVersionInfoAsString();
};

//--------------------------------------------------------------

