// type.h

#pragma once

#ifndef _TYPE_H_
#define _TYPE_H_

#include "afx.h"

//------------------------------------------------------------------------------

typedef unsigned char byte;
typedef byte Char;
typedef byte ByteBool;
typedef byte ByteInt;

//typedef __int32 PreInt;

#define BITS_IN_BYTE (8)
#define BITSIZEOF(x) (BITS_IN_BYTE*sizeof(x))

template<typename T>
struct type_traits
{
	static __int64 high_bit() { ASSERT(0); return 0; };
};

template<>
struct type_traits<__int64>
{
	static __int64 high_bit() { return 0x8000000000000000; };
//                                     0123456789abcdef
};

template <typename T>
T SHL_MSVC_IDE ( T x, T y )
{
	unsigned uy = unsigned(y) & 0xff;
	if ( uy >= BITSIZEOF(T) )
		return 0;
	else
		return x << uy;
}

template <typename T>
T SHR_MSVC_IDE ( T x, T y )
{
	unsigned uy = unsigned(y) & 0xff;
	if ( uy >= BITSIZEOF(T) )
	{
		if ( x & type_traits<T>::high_bit() )
			return T(-1);
		else
			return 0;
	}
	else
		return x >> uy;
}

//------------------------------------------------------------------------------

#endif // _TYPE_H_
